> For the complete documentation index, see [llms.txt](https://docs.bluefletch.com/bluefletch-enterprise/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/custom-intents/role-based-auto-launch.md).

# Filtering

## Overview <a href="#overview-0" id="overview-0"></a>

Managing the access and use of sensitive data is a key pillar of enterprise security. Role-based access control (RBAC) enables complex network environments to meet privacy and confidentiality regulations while securing business processes. Launcher's session application [layouts](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/configurable-layouts/layouts.md) are based on RBAC to simplify granting data only to relevant users. Intent filtering applies this same principle to the intents that can be triggered to automatically run on devices at various [device event](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/custom-intents/technical-guide.md#device-events) triggers.

## User Guide <a href="#user-guide-1" id="user-guide-1"></a>

Filtered intents allows IT administrators to determine what intents will run on specific Android enterprise devices based on the logged-in user's session, device, or extended attribute information.

## Feature Configuration <a href="#feature-configuration-2" id="feature-configuration-2"></a>

Intents can be filtered to match any session, device, or extended attribute [replacement variable](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/configurable-layouts/replacement-values.md) (for example: session.groups, session.location, session.userId, device.MODEL, device.BRAND, config.ex.deviceId, config.ex.siteId).

* Use the documented [key-value pairs](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/custom-intents/technical-guide.md#key-value-pairs) to build an intent
* Include a `"filter"` object where:
  * The replacement variable key is paired with a string
  * The string lists one or more values to include in the filter
    * Use a pipe ( | ) symbol when listing multiple values

```json
"intents" : {
    "login" : [
        // Start an app on login for users with at least one of two IdP groups:
        {
            "package": "com.application.inventory",
            "flags": 1,
            "typeIntent": "a",
            "filter": {
                "session.groups": "SalesAssociate|Receiving"
            }
        },
        // Disable an app on login at three sites:
        {
            "action": "DISABLE",
            "typeIntent": "p",
            "package" : "com.some.package"
            "filter": {
                "session.location": "1001|9309|4146"
            }
        }
    ],
    "logout": [
        // Clear browser app caches on logout for one particular device:
        {
            "action": "CLEARCACHE",
            "package": "com.bluefletch.ems.browser",
            "typeIntent": "p",
            "filter": {
                "config.ex.deviceId": "24000XXX39526"
            }
        }
    ]
}
```

Alternatively, filtering can be accomplished with and/or [criteria](/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/configurable-layouts/criteria.md) and regular expressions (regex).

{% hint style="info" %}
Intent filtering was introduced in Launcher 3.16.15.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.bluefletch.com/bluefletch-enterprise/product-guides/bluefletch-launcher/launcher3/custom-intents/role-based-auto-launch.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
